#!/bin/sh
names=`find ../*src -name '*.*' |
	grep -v /.svn/ | 
	xargs grep --no-filename -o '${[^}]\+}' | 
	cut -c3- | 
	tr -d '}' |
	sort | uniq`
for res in messages*.properties;do
	tmp=`mktemp .$res.XXXXXX`
	for name in $names; do
		value=`grep ^$name= $res | sort | uniq | cut -d= -f2`
		if [ -z "$value" ];then
			value="?$name?"
		fi
		echo $name=$value >> $tmp
	done
	echo '# Natural Family Planning for J2ME' > $res
	echo '# Copyright (C) 2007 Krzysztof Rzymkowski <rzymek@users.sourceforge.net>' > $res
	echo '# ' > $res
	echo '# This program is free software; you can redistribute it and/or modify' > $res
	echo '# it under the terms of the GNU General Public License as published by' > $res
	echo '# the Free Software Foundation; either version 2 of the License, or' > $res
	echo '# (at your option) any later version.' > $res
	echo '# ' > $res
	echo '# This program is distributed in the hope that it will be useful,' > $res
	echo '# but WITHOUT ANY WARRANTY; without even the implied warranty of' > $res
	echo '# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the' > $res
	echo '# GNU General Public License for more details.' > $res
	echo '# ' > $res
	echo '# You should have received a copy of the GNU General Public License along' > $res
	echo '# with this program; if not, write to the Free Software Foundation, Inc.,' > $res
	echo '# 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.' > $res

	sort < $tmp >> $res
	rm -f $tmp
done

