/* 
 * Natural Family Planning for J2ME
 * Copyright (C) 2007 Krzysztof Rzymkowski <rzymek@users.sourceforge.net>
 * 	
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License along
 * with this program; if not, write to the Free Software Foundation, Inc.,
 * 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.
 *
 */ 
 
package net.sf.nfp.mini.analize;

import net.sf.nfp.mini.misc.Interval;

public final class Analyzer {
	private static final int PREGNANCY_PROBABILITY_NONE = 0;
	private static final int PREGNANCY_PROBABILITY_LOW = 1;
	private static final int PREGNANCY_PROBABILITY_HIGH = 2;
	private int coverLineTemp = 0;
	private Interval ovulationInterval = null;

	/**
	 * @param period month's data - must be sorted by date
	 */
	/*
	public Analyzer(Period period) {
		this.period = period;
		
		Vector last6 = new Vector();		
		for (int i = period.getDays() - 1; i >= 0; --i) {
			Observation ob = (Observation) period.getDay(i);
			if (ob == null || ob.isDisturbed())
				continue;
			last6.addElement(ob);
			if (last6.size() < 9)
				continue;
			int minFrom3 = getMinMax(last6, 0, 3)[0];
			int maxFrom6 = getMinMax(last6, 3, 6)[1];
			int thirdTemp = ((Observation)last6.firstElement()).getTemperature();
			System.out.println("1 i=" + i + ", min=" + minFrom3 + ", max="
					+ maxFrom6 + ", third=" + thirdTemp + ", last6=" + last6);
			if (minFrom3 > maxFrom6 && thirdTemp >= maxFrom6 + 20) {
				System.out.println("returning after 3");
				coverLineTemp = maxFrom6 + 02;
				ovulationInterval = new Interval(period.getDays()-3, period.getDays());
				break;
			} else {
				System.out.println("trying 4");
				if(last6.size() < 10) {
					System.out.println("not enought:"+last6.size());
					continue;
				}
				minFrom3 = getMinMax(last6, 0, 4)[0];
				maxFrom6 = getMinMax(last6, 4, 6)[1];
				System.out.println("2 i="+i+", min="+minFrom3+", max="+maxFrom6+", last6="+last6);
				if(minFrom3 > maxFrom6) {
					System.out.println("returning after 4");
					coverLineTemp = maxFrom6 + 2;
					ovulationInterval = new Interval(period.getDays()-4, period.getDays());
					break;
				}
			}
		}
	}

	public final int getCoverLineTemp() {
		return coverLineTemp;
	}

	private int[] getMinMax(Vector last6, int start, int count) {
		int min = Integer.MAX_VALUE;
		int max = Integer.MIN_VALUE;
		for (int i = start; i < start + count; ++i) {
			Observation observation = (Observation) last6.elementAt(i);
			min = Math.min(min, observation.getTemperature());
			max = Math.max(max, observation.getTemperature());
		}
		return new int[] { min, max };
	}

	public final Interval getOvulation() {
		return ovulationInterval;
	}

	public final Interval getPeriod() {
		long startValue = Long.MAX_VALUE;
		long endValue = Long.MIN_VALUE;
		int startIndex = period.getDays()+1;
		int endIndex = period.getDays();
		for (int i = 0; i < period.getDays(); i++) {
			Observation ob = (Observation) period.getDay(i);
			if(ob == null || ob.isBleeding()==false)
				continue;
			if (startValue > ob.getDate().getTime()) {
				startValue = ob.getDate().getTime();
				startIndex = i;
			}
			if (endValue < ob.getDate().getTime()) {
				endValue = ob.getDate().getTime();
				endIndex = i+1;
			}
		}
		return new Interval(startIndex, endIndex);
	}

	public static int getPregnancyProbability(int i) {
		if (i < 5)
			return PREGNANCY_PROBABILITY_NONE;
		return i >= 10 ? PREGNANCY_PROBABILITY_HIGH : PREGNANCY_PROBABILITY_LOW;
	}

	private final Period period;
	*/
}
