package net.sf.nfp.mini.data;


import java.io.DataInputStream;
import java.io.DataOutputStream;
import java.io.IOException;

public class Mucus implements Persistent {
	public static final byte NONE = 0;
	public static final byte POOR = 1;
	public static final byte FINE = 2;
	
	public static final byte[] CATEGORIES = {
		NONE, POOR, FINE 
	};

	private int id;
	private byte category;
	private String name;
		
	public Mucus() {
	}
	
	public Mucus(int id, byte category, String description) {
		this.id = id;
		this.category = category;
		this.name = description;
	}


	public void writeTo(DataOutputStream out) throws IOException {
		out.writeByte(id);
		out.writeByte(category);
		out.writeUTF(name);
	}

	public void readFrom(DataInputStream in) throws IOException {
		id = in.readByte();		
		category = in.readByte();
		name = in.readUTF();
	}

	public String toString() {
		return name;
	}
	
	public byte getCategory() {
		return category;
	}

	public int getId() {
		return id;
	}

	public void setId(int id) {
		this.id = id;			
	}
}
