/* 
 * Natural Family Planning for J2ME
 * Copyright (C) 2007 Krzysztof Rzymkowski <rzymek@users.sourceforge.net>
 * 	
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License along
 * with this program; if not, write to the Free Software Foundation, Inc.,
 * 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.
 *
 */ 
 
package net.sf.nfp.mini.misc;

public class Color {
	private int color;

	public static final int WHITE = 0xffffff;
	public static final int BLACK = 0x000000;
	public static final int GREEN = 0x00ff00;
	public static final int RED = 0xff0000;
	public static final int BLUE = 0x0000ff;

	public Color(int color) {
		this.color = color;
	}

	public Color(int red, int green, int blue) {
		color = red << 16 | green << 8 | blue;
	}

	public int getRGB() {
		return color;
	}
	/**
	 * 0 - red
	 * 1 - green
	 * 2 - blue
	 * other - undefined
	 */
	public int getRGBComponent(int i) {
		return (color >> ((2-i)*8)) & 0xff;
	}

	public static Color blend(Color c1, Color c2) {
		int[] rgb = new int[3];
		for(int i=0;i<rgb.length;++i)
			rgb[i] = (c1.getRGBComponent(i) + c2.getRGBComponent(i)) / 2;
		return new Color(rgb[0],rgb[1],rgb[2]);
	}

}
