/* 
 * Natural Family Planning for J2ME
 * Copyright (C) 2007 Krzysztof Rzymkowski <rzymek@users.sourceforge.net>
 * 	
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License along
 * with this program; if not, write to the Free Software Foundation, Inc.,
 * 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.
 *
 */ 
 
package net.sf.nfp.mini.misc;

public class Interval
{
    public Interval(int start, int end)
    {
        this.start = start;
        this.end = end;
    }

    public final int getEnd()
    {
        return end;
    }

    public final int getStart()
    {
        return start;
    }

    public final boolean equals(Object obj)
    {
        Interval o;
        if((o = (Interval)obj) == null)
            return false;
        return o.start == start && o.end == end;
    }

    public static final Interval MAX = new Interval(Integer.MIN_VALUE, Integer.MAX_VALUE);
    private final int start;
    private final int end;

}
