/* 
 * Natural Family Planning for J2ME
 * Copyright (C) 2007 Krzysztof Rzymkowski <rzymek@users.sourceforge.net>
 * 	
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License along
 * with this program; if not, write to the Free Software Foundation, Inc.,
 * 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.
 *
 */ 
 
package net.sf.nfp.mini.misc;

public class Transformation {

	public Transformation(int startIn, int endIn, int startOut, int endOut) {
		this.inverted = endOut - startOut < 0;
		this.startIn = startIn;
		this.endOut = inverted ? endOut : startOut;
		this.distanceIn = Math.abs(endIn - startIn);
		this.distanceOut = Math.abs(endOut - startOut);
	}

	public int get(int x) {
		int tx = transform(x);
		if (inverted)
			tx = 1000 - tx;
		return (tx * distanceOut) / 1000 + endOut;
	}

	private int transform(int x) {
		return ((x - startIn) * 1000) / distanceIn;
	}

	private int startIn;
	private int endOut;
	private int distanceIn;
	private int distanceOut;
	private boolean inverted;
}
