package net.sf.nfp.mini.model;

import java.util.Calendar;
import java.util.Vector;

import javax.microedition.lcdui.Canvas;
import javax.microedition.lcdui.Command;
import javax.microedition.lcdui.Displayable;

import net.sf.mvc.mobile.Navigation;
import net.sf.mvc.mobile.command.ActionCommand;
import net.sf.mvc.mobile.command.NavigationCommand;
import net.sf.nfp.mini.data.Period;
import net.sf.nfp.mini.main.NFPControler;
import net.sf.nfp.mini.misc.Utils;
import net.sf.nfp.mini.view.HistoryView;
import net.sf.nfp.mini.view.KeyListener;

public class HistoryModel extends CommonModel implements KeyListener {

	private HistoryView view;

	public HistoryModel(NFPControler controler) {
		super(controler);
	}

	public void load(Object parameter) throws Exception {
		Period selected = (Period) parameter;
		int year = Calendar.getInstance().get(Calendar.YEAR);
		Vector periods = controler.getPeriodDAO().findByYear(year);
		view.setPeriods(periods);
		view.setSelectedPeriod(selected);
	}

	public void setView(Displayable v) {
		super.setView(v);
		view = (HistoryView) v;
		view.setKeyListener(this);
		view.setExceptionListener(controler);

		view.addCommand(new ActionCommand("${view}", Command.SCREEN, 1) {
			public Navigation execute(Displayable d) throws Exception {
				HistoryView history = (HistoryView) d;
				Period period = history.getSelectedPeriod();
				return new Navigation("graph", period, null);
			}
		});
		view.addCommand(new NavigationCommand("graph", "${back}", Command.BACK, 1));
	}

	public void keyPressed(int gameAction) {
		switch (gameAction) {
		case Canvas.LEFT:
			view.selectNext(Utils.DIRECTION_LEFT);
			break;
		case Canvas.RIGHT:
			view.selectNext(Utils.DIRECTION_RIGHT);
			break;
		}
	}
}
