package net.sf.nfp.mini.view;

import javax.microedition.lcdui.Canvas;
import javax.microedition.lcdui.Graphics;

public abstract class PropagatingCanvas extends Canvas {
	private KeyListener keyListener;
	private ExceptionListener exceptionListener;
	
	protected void keyPressed(int keyCode) {
		keyListener.keyPressed(getGameAction(keyCode));
	}
	
	protected final void paint(Graphics g) {
		try {
			safePaint(g);
		}catch(Exception ex){
			if(exceptionListener != null)
				exceptionListener.exception(ex);
			else
				throw new RuntimeException(ex+":"+ex.getMessage());
		}
	}
	
	protected abstract void safePaint(Graphics g) throws Exception;

	public void setKeyListener(KeyListener keyListener) {
		this.keyListener = keyListener;
	}
	
	public void setExceptionListener(ExceptionListener exceptionListener) {
		this.exceptionListener = exceptionListener;
	}	
}
